import 'dart:async';
import 'package:path/path.dart';
import 'package:sqflite/sqflite.dart';
import 'package:sqlentity/database/database-base.dart';

import 'package:sqlentity/database/database-config.dart';

///The AbstractRepository is the class that performs the interaction with the database,
///performs the updates and creation of the bank when necessary.
abstract class AbstractRepository {

  DataBaseBase _dataBaseBase = DataBaseBase();

  ///open database
  open() async {
    await _dataBaseBase.open();
  }

  ///close database
  Future close() async {
    await _dataBaseBase.close();
  }

  ///database instantiated and configured
  Database get database => _dataBaseBase.database;

}
